//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Generic2U.h"
#include <TypInfo.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void ChangeControls(const String Prop,
  const TVarRec *SetTo,
  const int SetTo_Size,
  TComponent * const * ControlsToChange,
  const int ControlsToChange_Size)
{
  for (int i = 0; i <= ControlsToChange_Size; i++)
  {
    PPropInfo PropInfo = GetPropInfo(
      (PTypeInfo)ControlsToChange[i]->ClassInfo(), Prop);
    if (PropInfo)
      switch (SetTo->VType)
      {
        case vtInteger: ;
        case vtBoolean: ;
        case vtChar:
          SetOrdProp(
            static_cast<TObject *>(ControlsToChange[i]),
            PropInfo, SetTo->VInteger);
          break;
        case vtExtended:
          SetFloatProp(
            static_cast<TObject *>(ControlsToChange[i]),
            PropInfo, *(SetTo->VExtended));
          break;
        case vtString:
          SetStrProp(
            static_cast<TObject *>(ControlsToChange[i]),
            PropInfo, *(SetTo->VString));
      }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button1Click(TObject *Sender)
{
  ChangeControls("Enabled", ARRAYOFCONST((False)),
    OPENARRAY(TComponent *, (Button1, Edit1, About1)));
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button2Click(TObject *Sender)
{
  ChangeControls("Enabled", ARRAYOFCONST((True)),
    OPENARRAY(TComponent *, (Button1, Edit1, About1)));
}
//---------------------------------------------------------------------------

void __fastcall TForm2::About1Click(TObject *Sender)
{
  MessageDlg("About Box", mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------
  