//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GenericU.h"
#include <TypInfo.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void ActivateControls(bool SetTo,
  TComponent * const *ControlsToChange,
  const int ControlsToChange_Size)
{
  for (int i = 0; i <= ControlsToChange_Size; i++)
  {
    PPropInfo PropInfo = GetPropInfo(
      (PTypeInfo)ControlsToChange[i]->ClassInfo(), "Enabled");
    if (PropInfo)
      SetOrdProp(static_cast<TObject *>(ControlsToChange[i]),
        PropInfo, (int)SetTo);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  ActivateControls(False,
    OPENARRAY(TComponent *, (Button1, Edit1, About1)));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  ActivateControls(True,
    OPENARRAY(TComponent *, (Button1, Edit1, About1)));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
  MessageDlg("About Box", mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------
 